Page MenuHomePhabricator

Move language button to the bottom of Main pages
Closed, ResolvedPublic3 Estimated Story Points

Description

Description

As part of the Desktop Improvements project we are moving language links (ie language switching) from the sidebar to the page heading area (prototype).

image.png (620×1 px, 180 KB)

Main pages don't have page headings, so where should language links appear on Main pages? Many Main pages already have language links panels on them, which perhaps can point us in the right direction. The purpose of this task is to discuss what solutions we might be able to provide (or at least guide) for the Wikipedias who want language links on the main page and don't already have a language links panel.

Acceptance criteria

  • Button should be left aligned on LTR and right aligned on RTL at the bottom of the page
  • On all other pages the position should stay the same.

Proposed solutions

Two specific notes about some of the existing language link panels:

Putting relevant languages first
While most main page language modules order the links by the # of articles in that respective language, some modules put relevant languages first (or otherwise highlight relevant languages) which seems like a good practice:

Using the language icon within the module
At least one language links panel uses the language icon that is used elsewhere in the website, this seems like a helpful practice to further build the connection between the icon and the concept of languages.

Mockups
Examples of how language panels might look on English Wikipedia's homepage:

image.png (480×1 px, 206 KB)
image.png (458×1 px, 177 KB)
image.png (527×1 px, 121 KB)

Other examples of main pages with language panels
(this list is nowhere near complete)

QA Results - Beta

ACStatusDetails
1T276140#7100637
2T276140#7100637

Event Timeline

There are a very large number of changes, so older changes are hidden. Show Older Changes

@ovasileva @Jdlrobson @sgrabarczuk it is currently unclear what the next steps might be here. In the hope of clarifying that: what kind of commitment do we want to take on here? For example do we imagine a direct/hands-on approach where we build templates and implement them on main pages? Or more of an indirect/hands-off approach where we alert communities that the language links are moving and advise them to add a panel to their Main pages.

I would suggest creating a phabricator ticket/wiki page with recommendations.

I would then suggest publicizing this via tech news (User-notice) and linking to it from Desktop improvements mediawiki page.

cc @Pginer-WMF for visibility, also wondering if you think mentioning translation in these panels might make sense?

cc @Pginer-WMF for visibility, also wondering if you think mentioning translation in these panels might make sense?

The proposal looks good.

I don't see a strong need to add an option to translate in this particular context. It seems targeted to readers and translations cannot support creating a Wikipedia project if it is missing on a particular language. So it would not work as a natural follow-up (create missing language). In this context, translation would be just another way to contribute, slightly more relevant than others because the association with language, but probably not enough to crowd that space.

Needs priority. If doing this we should do this prior to the language deploy.

ovasileva triaged this task as Medium priority.Mar 4 2021, 11:17 AM

@Jdlrobson, @alexhollender - this one would be follow-up from our initial language work. If we commit to it, I would say we try to tackle it towards the end of the project.

We've had a number of conversations about this off-task. @Jdlrobson could you add a comment here with your current thinking, and possibly some rough idea of what the language button at the bottom of the main page would look like?

Most projects do #firstHeading { display: none; } (English Wikipedia for example) so for most wikis this is what the main page is going to look like if we do nothing:

Screen Shot 2021-03-24 at 10.13.30 AM.png (1×2 px, 500 KB)

That's not exactly broken.

If projects want to hide that it's pretty easy for them to do that with a style rule in their MediaWiki:Vector.css

They can also place the button at the bottom of page like so using this CSS:

Screen Shot 2021-03-24 at 10.39.57 AM.png (962×2 px, 338 KB)

possibly some rough idea of what the language button at the bottom of the main page would look like?

Try out https://en.wikipedia.beta.wmflabs.org/wiki/Main_Page

Jdlrobson renamed this task from [Spike] Language switching from Main pages to Move language button to the bottom of Main pages.Apr 28 2021, 5:17 PM
Jdlrobson updated the task description. (Show Details)
LGoto set the point value for this task to 3.Apr 28 2021, 5:24 PM
ovasileva raised the priority of this task from Medium to High.Apr 29 2021, 10:22 AM

@Jdlrobson I think a CSS-only approach has some issues. If it were implemented on a per-wiki basis, that would be fine, but as a default for new Vector, without any site styles, the result would look like this:

Screen Shot 2021-05-01 at 10.39.57 AM.png (1×1 px, 251 KB)

I think we should instead move the button HTML at the PHP/mustache template level and avoid adding context specific CSS.

As a side-note, I think we should consider renaming this feature as a followup task T281623.

Change 684413 had a related patch set uploaded (by Jdrewniak; author: Jdrewniak):

[mediawiki/skins/Vector@master] Place language button near bottom of Main page.

https://gerrit.wikimedia.org/r/684413

Jdrewniak added a subscriber: Jdrewniak.

Change 684413 merged by jenkins-bot:

[mediawiki/skins/Vector@master] Place language button near bottom of Main page.

https://gerrit.wikimedia.org/r/684413

Seems like this is causing an issue on the beta cluster where only the no-js version of the language switcher is available.

Screen Shot 2021-05-07 at 10.56.20 AM.png (1×2 px, 939 KB)

Change 686466 had a related patch set uploaded (by Jdrewniak; author: Jdrewniak):

[mediawiki/skins/Vector@master] Fix: update to 80d734b4, hide language dropdown when ULS loads

https://gerrit.wikimedia.org/r/686466

Change 686466 merged by jenkins-bot:

[mediawiki/skins/Vector@master] Fix: update to 80d734b4, hide language dropdown when ULS loads

https://gerrit.wikimedia.org/r/686466

Where is the "🖉Edit links/Add links" now?

Status: ✅ PASS
Environment: beta
OS: macOS Big Sur
Browser: Chrome
Device: MBP
Emulated Device: NA

Test Artifact(s):

QA Steps

✅ AC1: Button should be left-aligned on LTR and right-aligned on RTL at the bottom of the page

Screen Shot 2021-05-20 at 6.19.50 AM.png (1×1 px, 451 KB)

Screen Shot 2021-05-20 at 6.21.14 AM.png (1×1 px, 307 KB)

✅ AC2: On all other pages the position should stay the same.

Screen Shot 2021-05-20 at 6.20.21 AM.png (1×1 px, 539 KB)

Screen Shot 2021-05-20 at 6.30.40 AM.png (1×1 px, 402 KB)

Confirming this is okay in production and resolving

Screen Shot 2021-05-24 at 12.17.54 PM.png (1×2 px, 337 KB)

Today I was with two different users who were exploring content in Wikipedia. One of them noted me this issue, as they couldn't find the language button (they were trying to find it in the same place where you can find at articles). The second one said me why they couldn't find links to artiles in other languages, not even trying to search for the button itself. I think that the change of the button to the top right should be consisten. Below everything is buried and impossible to find.

I opened a bug report here: T290480. Don't know if this should sitewide or solved at a local leve.

I reopen this, as the bug I reported has been closed.

Sorry @JJMC89, I disagree. This is not closed, as the solution is making things worse.

This ticket is called "Move language button to the bottom of Main pages", that has clearly been resolved. :) I'd suggest raising this topic on https://www.mediawiki.org/wiki/Talk:Reading/Web/Desktop_Improvements which seems to be a better place for discussing use cases and underlying problems with the existing behavior.

I disagree @Aklapper. Problems at the talk page are never solved. So it seems that something is being pushed at some test-case Wikis, and all the feedback is being deleted. If we raise a concern at the talk page, they point us to Phabricator. If we raise a bug (THIS IS A BUG) at Phabricator, they point us to the talk page. No solution. Really annoying.

I have taken the overall visits of four languages spoken in France besides french:

  • Occitan
  • Breton
  • Corsican
  • Alsacian

I have downloaded visits during 2020 september and 2021 september using Siteviews tool. The result wouldn't be surprising to anyone who has thought on how hiding the interwiki link should affect smaller projects that can't be reached easily via Google search.

The combined views for this 4 projects during September 2020 was 1.358.349 pageviews (excluding special pages). For September 2021 is 1.192.619. Is a decrease of 12% (165.731 views less). I wonder how this aligns with the 2030 Strategy.